#include <stdio.h>

short calls[100];
const char *flags[]={"0", "1", "2", "nz", "l", "g", "ge", "7"};

int disp(unsigned char raw)
{
    if (raw & 0x80) {
        return -((raw^0xFF)+1);
    }
    else
        return raw & 0xFF;
}

void decode_vm(unsigned short *prog, int pc)
{
    int i = pc, j;
    int ncall = 0;
    unsigned short opcode;
   
    while (i <= 0x1DD/2) {
        opcode = prog[i];
        for (j= 0 ; j < ncall; j++)
            if (calls[j] == i*2) {
                printf("\nloc_0x%x : \n", i*2);
                break;
           }

        printf("%04x : %02X %02x : ", i*2, opcode&0xFF, opcode>>8);
        if(opcode == 0x0Fd0){
            printf("ret\n\n");
        } else {
            switch((opcode>>4)&0xF){
                case 1:
                    printf("or r%d, 0x%x\n", opcode&0xF, ((opcode>>8)&0xFF));
                    break;
                case 2:
                    printf("lh r%d, 0x%x\n", opcode&0xF, ((opcode>>8)&0xFF));
                    break;
                case 3:
                    printf("xor r%d, r%d\n", opcode&0xF, (opcode>>8)&0xF);
                    break;
                case 4:
                    printf("add r%d, r%d, r%d\n", opcode&0xF, (opcode>>8)&0xF, (opcode>>12)&0xF);
                    break;
                case 5:
                    printf("mov r%d, r%d\n", opcode&0xF, (opcode>>8)&0xF);
                    break;
                case 6:
                    printf("add r%d, r%d, r%d\n", opcode&0xF, (opcode>>8)&0xF, (opcode>>12)&0xF);
                    break;
                case 0x7:
                    printf("sub r%d, r%d, r%d\n", opcode&0xF, (opcode>>12)&0xF, (opcode>>8)&0xF) ;
                    break;
                case 8:
                    printf("mul r%d, r%d, r%d\n", opcode&0xF, (opcode>>8)&0xF, (opcode>>12)&0xF);
                    break;
                case 9:
                    printf("mod r%d, r%d, r%d\n", opcode&0xF, (opcode>>8)&0xF, (opcode>>12)&0xF);
                    break;
                case 0xa:
                    printf("j.%d, loc_0x%x\n\n", opcode&0xF, ((i+1)*2)+disp(opcode>>8));
                    calls[ncall++] =  (i+1)*2+(disp(opcode>>8));
                    break;
                case 0xb:
                    if((opcode & 0xF) == 3) {
                        printf("jmp loc_0x%x\n\n", (i+1)*2+disp(opcode>>8));
                        calls[ncall++] =  (i+1)*2+(disp(opcode>>8));
                    } else {
                    printf("%04x\n", opcode); 
                    }
                    break;
                case 0xc:
                    if((opcode & 0xF) != 8) {
                        printf("call loc_0x%x\n\n", (i+1)*2+(((opcode&0xF)<<8)|((opcode>>8)&0xFF)));
                        calls[ncall++] =  (i+1)*2+(((opcode&0xF)<<8)|((opcode>>8)&0xFF));
                    } else {
                        printf("syscall %x\n\n", opcode>>8);
                    }
                    break;
                case 0xD:
                    printf("call r%d\n", opcode&0xF);
                    break;
                case 0xE:
                    printf("mov r%d, [r%d+r%d]\n", opcode&0xF, (opcode>>8)&0xF, (opcode>>12)&0xF);
                    break;
                case 0xF:
                    printf("mov [r%d+r%d], r%d\n", (opcode>>8)&0xF, (opcode>>12)&0xF, opcode&0xF);
                    break;
                default:
                    printf("%04x\n", opcode); 
            }
        }
        i++;
    }
}


int main(int argc, char *argv[])
{
    FILE *fin;
    unsigned char data[65536];

    if(argc < 2) {
        return 1;
    }
    fin = fopen(argv[1], "rb");
    fread(data, 1, 65536, fin);
    fclose(fin);

    decode_vm((unsigned short *)data, 0);
    return 0;
}
