#include <stdio.h>

const char *flags[]={"0", "1", "2", "nz", "l", "g", "ge", "7"};
void decode_vm(unsigned char *prog, int pc)
{
    int i = pc;
    unsigned char opcode;
    unsigned int data;
   
    while (i <= 0x326) {
        opcode = prog[i];
        printf("%04x : ", i);
        if (opcode <= 8) {
            data = ((unsigned int *)(prog+i))[0];
            i+=4;
        } else {
            data = ((unsigned short *)(prog+i))[0];
            i+=2;
        }
        switch(opcode){
            case 0:
                printf("lh r%d, 0x%x\n", (data>>8)&0xF, ((data>>12)&0xFFFF));
                break;
            case 1:
                printf("ll r%d, 0x%x\n", (data>>8)&0xF, ((data>>12)&0xFFFF));
                break;
            case 2:
                printf("mov r%d, dword ptr [r%d+%x]\n", (data>>8)&0xF, (data>>12)&0xF, ((data>>16)&0xFFFF));
                break;
            case 4:
                printf("mov r%d, byte ptr [r%d+%x]\n", (data>>8)&0xF, (data>>12)&0xF, ((data>>16)&0xFFFF));
                break;
            case 7:
                printf("mov byte ptr [r%d+0x%x], r%d\n", (data>>12)&0xF, (data>>16), (data>>8)&0xF);
                break;
            case 8: /* probablement un cmp */
                printf("j.%s r%d, (%x)\n", flags[(data>>13)&0x7], (data>>9)&0xF, data>>16);
                break;
            case 0xA: /* TODO : check*/
                printf("xor r%d, r%d\n", (data>>8)&0xF, ((data>>12)&0xF));
                break;
            case 0xB: 
                printf("or r%d, r%d\n", (data>>8)&0xF, ((data>>12)&0xF));
                break;
            case 0xC: 
                printf("and r%d, r%d\n", (data>>8)&0xF, ((data>>12)&0xF));
                break;
            case 0xD: 
                printf("shl r%d, r%d\n", (data>>8)&0xF, ((data>>12)&0xF));
                break;
            case 0xE: 
                printf("shr r%d, r%d\n", (data>>8)&0xF, ((data>>12)&0xF));
                break;
            case 0x12:
                printf("add r%d, r%d\n", (data>>8)&0xF, ((data>>12)&0xF));
                break;
            case 0x13:
                printf("sub r%d, r%d\n", (data>>8)&0xF, ((data>>12)&0xF));
                break;
            case 0x16: 
                printf("inc r%d\n", (data>>8)&0xF);
                break;
            case 0x17: 
                printf("dec r%d\n", (data>>8)&0xF);
                break;
            case 0x1c:
                printf("call exit?\n");
                break;
            case 0x1d:
                printf("call read_write\n");
                break;
            case 0x1e:
                printf("lfsr r%d, r%d\n", (data>>8)&0xF, ((data>>12)&0xF));
                break;
            default:
                printf("%02x %08x\n", opcode, data); 
        }
    }
}


int main(int argc, char *argv[])
{
    FILE *fin;
    unsigned char data[65536];
    int ptr = 0x40;

    if(argc < 2) {
        return 1;
    }
    fin = fopen(argv[1], "rb");
    fread(data, 1, 65536, fin);
    fclose(fin);

    decode_vm(data, ptr);
    return 0;
}
